// Setup.cpp : implementation file
//

#include "stdafx.h"
#include "MP5Series.h"
#include "Setup.h"
#include "MP5SeriesDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetup dialog


CSetup::CSetup(CWnd* pParent /*=NULL*/)
	: CDialog(CSetup::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetup)
	m_BaudRate = -1;
	m_DataBit = -1;
	m_ParityBit = -1;
	m_Port = -1;
	m_StopBit = -1;
	m_Unit = _T("");
	m_Addr = _T("");
	m_C0 = _T("");
	m_C1 = _T("");
	m_C2 = _T("");
	m_C3 = _T("");
	m_K0 = _T("");
	m_K1 = _T("");
	m_P0 = _T("");
	m_X0 = _T("");
	m_X1 = _T("");
	m_Y0 = _T("");
	m_Y1 = _T("");
	m_Bank = _T("");
	//}}AFX_DATA_INIT
}


void CSetup::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetup)
	DDX_Control(pDX, IDC_PROGRESS_LOAD, m_Progress);
	DDX_CBIndex(pDX, IDC_COMBO_BAUDRATE, m_BaudRate);
	DDX_CBIndex(pDX, IDC_COMBO_DATA, m_DataBit);
	DDX_CBIndex(pDX, IDC_COMBO_PARITY, m_ParityBit);
	DDX_CBIndex(pDX, IDC_COMBO_PORT, m_Port);
	DDX_CBIndex(pDX, IDC_COMBO_STOP, m_StopBit);
	DDX_Text(pDX, IDC_EDIT_UNIT, m_Unit);
	DDX_Text(pDX, IDC_STATIC_ADDR, m_Addr);
	DDX_Text(pDX, IDC_STATIC_C0, m_C0);
	DDX_Text(pDX, IDC_STATIC_C1, m_C1);
	DDX_Text(pDX, IDC_STATIC_C2, m_C2);
	DDX_Text(pDX, IDC_STATIC_C3, m_C3);
	DDX_Text(pDX, IDC_STATIC_K0, m_K0);
	DDX_Text(pDX, IDC_STATIC_K1, m_K1);
	DDX_Text(pDX, IDC_STATIC_P0, m_P0);
	DDX_Text(pDX, IDC_STATIC_X0, m_X0);
	DDX_Text(pDX, IDC_STATIC_X1, m_X1);
	DDX_Text(pDX, IDC_STATIC_Y0, m_Y0);
	DDX_Text(pDX, IDC_STATIC_Y1, m_Y1);
	DDX_Text(pDX, IDC_STATIC_BANK, m_Bank);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetup, CDialog)
	//{{AFX_MSG_MAP(CSetup)
	ON_BN_CLICKED(IDC_BUTTON_RELOAD, OnButtonReload)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetup message handlers

BOOL CSetup::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here
	m_pMP5SeriesDlg->m_ReceiveMsg.ShowWindow(SW_HIDE);
	m_pMP5SeriesDlg->m_Progress.ShowWindow(SW_SHOW);
	Reload(&m_pMP5SeriesDlg->m_Progress);
	m_pMP5SeriesDlg->m_Progress.ShowWindow(SW_HIDE);
	m_pMP5SeriesDlg->m_ReceiveMsg.ShowWindow(SW_SHOW);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSetup::Reload(CProgressCtrl* pProgress)
{
	CString str;
	stValue parameter;

	if(!pProgress) return;

	memset(&parameter, 0, sizeof(stValue));

	m_pMP5SeriesDlg->ParameterLoad((void*)&parameter, pProgress);

	m_Addr.Format("%02d", parameter.addr);
	m_P0.Format("%g",parameter.value);
	m_C0.Format("%g",parameter.hh);
	m_C1.Format("%g",parameter.h);
	m_C2.Format("%g",parameter.l);
	m_C3.Format("%g",parameter.ll);
	m_K0.Format("%g",parameter.peak_max);
	m_K1.Format("%g",parameter.peak_min);
	m_X0.Format("%g",parameter.prescale_x_a);
	m_X1.Format("%g",parameter.prescale_x_b);
	m_Y0.Format("%g",parameter.prescale_y_a);
	m_Y1.Format("%g",parameter.prescale_y_b);

	UpdateData(FALSE);
}

void CSetup::OnButtonReload() 
{
	// TODO: Add your control notification handler code here
	Reload(&m_Progress);
}
